dpkg-buildpackage(1)

NAME
dpkg-buildpackage - build binary or source packages from sources

SYNOPSIS
dpkg-buildpackage [options]

DESCRIPTION
dpkg-buildpackage is a control script which can be used to help automate the building of a package.

OPTIONS

-b  Specifies a binary-only build, no source files are to be built and/or distributed.

-B  Specifies a binary-only build, no architecture independent binary package files are to be distributed either.

-S  Specifies a source-only build, no binary packages need to be made.

The -sx options control whether the original source archive is included in the upload if any source is being generated (i.e. -b or -B haven't been used).

-si By default, or if specified, the original source will be included only if the upstream version number (the version without epoch and without Debian revision) differs from the upstream version number of the previous changelog entry.

-sa Forces the inclusion of the original source.

-sd Forces the exclusion of the original source and includes only the diff.

-aarchitecture
    Specify the Debian architecture we build for. The architecture of the machine we build on is determined automatically, and is also the default for the host machine. If the host architecture differs from the build architecture (as is the case for a cross-compilation), and if the environment variable PKG_CONFIG_LIBDIR is not set, then it is set to a value suitable for cross-compilation ("/usr/gnu-system-type/lib/pkgconfig/:/usr/share/pkgconfig").

-tgnu-system-type
    Specify the GNU system type we build for. It can be used in place of -a or as a complement to override the default GNU system type of the target Debian architecture.

-jjobs
    Number of jobs allowed to be run simultaneously, equivalent to the make(1) option of the same name. Will add itself to the MAKEFLAGS environment variable, which should cause all subsequent make invocations to inherit the option. Also adds parallel=jobs to the DEB_BUILD_OPTIONS environment variable which allows debian/rules files to use this information for their own purposes. The parallel=jobs in DEB_BUILD_OPTIONS environment variable will override the -j value if this option is given.

-vversion
    Use changelog information from all versions strictly later than version.

-Cchangesdescription
    Read the description of the changes from the file changesdescription rather than using the information from the source tree's changelog file.

-mmaintaineraddress
    Use maintaineraddress as the name and email address of the maintainer for this package, rather than using the information from the source tree's control file.

-emaintaineraddress
    Use maintaineraddress as the name and email address of the maintainer for this upload, rather than using the information from the source tree's changelog.

-D  Check build dependencies and conflicts; abort if unsatisfied.

-d  Do not check build dependencies and conflicts.

-E  Turn certain warnings into errors. Only dpkg-source uses this, but dpkg-buildpackage recognizes it, and passes it thru to dpkg-source.

-W  Negates a previously set -E. Only dpkg-source uses this, but dpkg-buildpackage recognizes it, and passes it thru to dpkg-source.

-nc Do not clean the source tree (implies -b).

-tc Clean the source tree (using gain-root-command debian/rules clean) after the package has been built.

-rgain-root-command
    When dpkg-buildpackage needs to execute part of the build process as root, it prefixes the command it executes with gain-root-command if one has been specified. Otherwise, if none has been specified, fakeroot will be used by default, if the command is present. gain-root-command should start with the name of a program on the PATH and will get as arguments the name of the real command to run and the arguments it should take. gain-root-command can include parameters (they must be space-separated) but no shell metacharacters. gain-root-command might typically be fakeroot, sudo, super or really. su is not suitable, since it can only invoke the user's shell with -c instead of passing arguments individually to the command to be run.

-Rrules-file
    Building a Debian package usually involves invoking debian/rules as a command with several standard parameters. With this option it's possible to use another program invocation to build the package (it can include space separated parameters). Alternatively it can be used to execute the standard rules file with another make program (for example by using /usr/local/bin/make -f debian/rules as rules-file).

-psign-command
    When dpkg-buildpackage needs to execute GPG or PGP to sign a source control (.dsc) file or a .changes file it will run sign-command (searching the PATH if necessary) instead of pgp. sign-command will get all the arguments that pgp would have gotten. If sign-command takes its arguments in GPG rather than PGP style, you should give the -sgpg option. sign-command should not contain spaces or any other shell metacharacters.

-kkey-id
    Specify a key-ID to use when signing packages.

-us Do not sign the source package.

-uc Do not sign the .changes file.

-i[regexp]
    Passed unchanged to dpkg-source.

-I[pattern]
    Passed unchanged to dpkg-source. May be repeated multiple times.

-s[nsAkurKUR]
    Passed unchanged to dpkg-source.

-z, -Z
    Passed unchanged to dpkg-source.

--admindir=dir
    Change the location of the dpkg database. The default location is /var/lib/dpkg.

-h, --help
    Show the usage message and exit.

--version
    Show the version and exit.

ENVIRONMENT
A set of environment variables for setting compiler and linker options are set to default values unless already set in the environment. Note that this mechanism was only introduced in dpkg-dev, version 1.14.17 and not all rules files and build tools will honour these variables, yet.

CFLAGS
    Optimization options which are passed to the Debian build system and can/should be overriden by the package build if needed (default value: -g -O2, or -g -O0 if noopt is specified in DEB_BUILD_OPTIONS). Overriding options can be used to explicitely set a higher optimization level, or work around compiler bugs, which only can be seen with some optimization levels (the last opt level "wins").

CFLAGS_APPEND
    Optimization options appended to the compiler flags, which must not be overwritten by the package (mostly used to for test builds). Default value: empty.

CXXFLAGS
    Same as CFLAGS for C++ sources.

CXXFLAGS_APPEND
    Same as CFLAGS_APPEND for C++ sources.

FFLAGS
    Same as CFLAGS for Fortran sources.

FFLAGS_APPEND
    Same as CFLAGS_APPEND for Fortran sources.

CPPFLAGS
    Preprocessor flags which are passed to the Debian build system and can/should be overriden by the package build if needed (default: empty). This macro is seldom used (most build systems just use CFLAGS instead of CPPFLAGS).

CPPFLAGS_APPEND
    Preprocessor flags appended to the preprocessor flags, which must not be overwritten by the package (mostly used to for test builds). Default value: empty.

LDFLAGS
    Options passed to the compiler when linking executables or shared objects (if the linker is called directly, then -Wl and , have to be stripped from these options. Default value: empty.

LDFLAGS_APPEND
    Optimization options appended to the compiler flags when linking code, which must not be overwritten by the package (mostly used to for test builds). Default value: empty.

BUGS
It should be possible to specify spaces and shell metacharacters in and initial arguments for gain-root-command and sign-command.

SEE ALSO
dpkg-source(1), dpkg-architecture(1), dpkg-genchanges(1), gpg(1), pgp(1).

AUTHORS
Copyright (C) 1995-1996 Ian Jackson
Copyright (C) 2000 Wichert Akkerman
Copyright (C) 2007 Frank Lichtenheld

This is free software; see the GNU General Public Licence version 2 or later for copying conditions. There is NO WARRANTY.